// logoptsd.cpp : implementation file
//

#include "stdafx.h"
#include "tricarb.h"
#include "logoptsd.h"
#include "comfns.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLogOptsDlg dialog


CLogOptsDlg::CLogOptsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLogOptsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLogOptsDlg)
	m_bLogOuterrors = FALSE;
	m_bLogComErrors = FALSE;
	m_bLogOnline = FALSE;
	m_bLogPowerfail = FALSE;
	m_bLogProtocol = FALSE;
	m_bLogConvertErrors = FALSE;
	m_bLimit = FALSE;
	m_szLimit = "";
	//}}AFX_DATA_INIT
}

void CLogOptsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLogOptsDlg)
	DDX_Check(pDX, IDC_OUTERRORS, m_bLogOuterrors);
	DDX_Check(pDX, IDC_ERRORS, m_bLogComErrors);
	DDX_Check(pDX, IDC_ONLINE, m_bLogOnline);
	DDX_Check(pDX, IDC_POWERFAIL, m_bLogPowerfail);
	DDX_Check(pDX, IDC_PROTOCOL, m_bLogProtocol);
	DDX_Check(pDX, IDC_CONVERTERRORS, m_bLogConvertErrors);
	DDX_Check(pDX, IDC_LIMIT, m_bLimit);
	DDX_Text(pDX, IDC_EDIT1, m_szLimit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLogOptsDlg, CDialog)
	//{{AFX_MSG_MAP(CLogOptsDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CLogOptsDlg message handlers

BOOL CLogOptsDlg::OnInitDialog()
{
	char buffer[7];
	
	CDialog::OnInitDialog();
	
	::CenterWindow(GetParent(), this);    // center dialog in frame window
	
	m_szLimit = _itoa(m_nLimit, buffer, 10);
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CLogOptsDlg::OnOK()
{
	CDialog::OnOK();
	
	m_nLimit = atoi((const char*)m_szLimit);
	if (m_nLimit < 0)
	{
		m_nLimit = 0;
	}
	if (m_nLimit > 32767)
	{
		m_nLimit = 32767;
	}
}